// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];

var snridMBTemperature =       (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridCPU1Temperature =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0110;
var snridCPU2Temperature =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0120;

var snridVcore1Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;
var snridVcore2Voltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0120;

var snridFan8Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0180;
var snridFan9Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0190;
var snridHotFan1Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3110;
var snridHotFan2Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3120;
var snridHotFan3Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3130;
var snridHotFan4Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3140;
var snridHotFan5Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3150;
var snridHotFan6Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3160;
var snridHotFan7Speed =        (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x3170;

var snridBkpl1Bay1Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1110;
var snridBkpl1Bay2Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1120;
var snridBkpl1Bay3Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1130;
var snridBkpl2Bay1Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1210;
var snridBkpl2Bay2Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1220;
var snridBkpl3Bay1Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1310;
var snridBkpl3Bay2Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1320;
var snridBkpl3Bay3Plug =        (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1330;

var snridPower1Plug =          (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x2110;
var snridPower2Plug =          (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x2210;
var snridPower1AC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2120;
var snridPower2AC =            (parent.asID['ASWM_SNRTYPE_POWER'] << 16) + 0x2220;
var snridPowerFan1 =           (parent.asID['ASWM_SNRTYPE_POWERFANSTATUS'] << 16) + 0x2130;
var snridPowerFan2 =           (parent.asID['ASWM_SNRTYPE_POWERFANSTATUS'] << 16) + 0x2230;

var compPCI = new SysComponentInfo ('PCI', "parent.I18N['EXPANDSLOTS']", 'info_pci.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI)
    )
);
var compRiser = new SysComponentInfo ('RISER', "parent.I18N['RISERBOARD']", 'info_riser.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 3, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 3, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 4, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 4, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 5, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 5, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 7).extra", snsridHasDMI)
    )
);
var compBackplaneBoard1 = new SysComponentInfo ('BACKPLANEBOARD1', "parent.I18N['BACKPLANE'] + ' 1'", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "'BP3LS-AR21'", snsridHasFRU)
    )
);
var compBackplaneBoard2 = new SysComponentInfo ('BACKPLANEBOARD2', "parent.I18N['BACKPLANE'] + ' 2'", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "'BP3LS-AR21'", snsridHasFRU)
    )
);
var compBackplaneBoard3 = new SysComponentInfo ('BACKPLANEBOARD3', "parent.I18N['BACKPLANE'] + ' 3'", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "'BP3LS-AR21'", snsridHasFRU)
    )
);

var compChassisFan1 = new SysComponentInfo ('CHAFAN1', "parent.once.GSensorNames[parent.once.snridFan8Speed]", 'info_fan_s.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan8Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan8Speed).unit]", snridFan8Speed)
    )
);
var compChassisFan2 = new SysComponentInfo ('CHAFAN2', "parent.once.GSensorNames[parent.once.snridFan9Speed]", 'info_fan_s.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan9Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan9Speed).unit]", snridFan9Speed)
    )
);

var compHotFan1 = new SysComponentInfo ('HOTFAN1', "parent.once.GSensorNames[parent.once.snridHotFan1Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan1Speed).unit]", snridHotFan1Speed)
    )
);
var compHotFan2 = new SysComponentInfo ('HOTFAN2', "parent.once.GSensorNames[parent.once.snridHotFan2Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan2Speed).unit]", snridHotFan2Speed)
    )
);
var compHotFan3 = new SysComponentInfo ('HOTFAN3', "parent.once.GSensorNames[parent.once.snridHotFan3Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan3Speed).unit]", snridHotFan3Speed)
    )
);
var compHotFan4 = new SysComponentInfo ('HOTFAN4', "parent.once.GSensorNames[parent.once.snridHotFan4Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan4Speed).unit]", snridHotFan4Speed)
    )
);
var compHotFan5 = new SysComponentInfo ('HOTFAN5', "parent.once.GSensorNames[parent.once.snridHotFan5Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan5Speed).unit]", snridHotFan5Speed)
    )
);
var compHotFan6 = new SysComponentInfo ('HOTFAN6', "parent.once.GSensorNames[parent.once.snridHotFan6Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan6Speed).unit]", snridHotFan6Speed)
    )
);
var compHotFan7 = new SysComponentInfo ('HOTFAN7', "parent.once.GSensorNames[parent.once.snridHotFan7Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridHotFan7Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridHotFan7Speed).unit]", snridHotFan7Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.theSysInfo.quadrupleExtraAt(9)", "parent.once.theSysInfo.pairAt(9)"),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature).unit]", snridMBTemperature),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).unit]", snridCPU1Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).unit]", snridCPU2Temperature)
    )
);
var compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
    new Tuple (
        new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 5, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 5, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 6, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 6, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 7, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 7, 9).value)", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 8, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 8, 9).value)", snsridHasDMI)
    )
);
var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcore1Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU1Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU1Temperature).unit]", snridCPU1Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore1Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore1Voltage).unit]", snridVcore1Voltage)
    )
);
var compCPU2 = new SysComponentInfo ('CPU2', "parent.I18N['CPU'] + ' 2'", 'info_cpu2.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 2, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 2, 13).value + 'Mhz'", snridVcore2Voltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPU2Temperature]", "parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPU2Temperature).unit]", snridCPU2Temperature),
        new triple ("parent.once.GSensorNames[parent.once.snridVcore2Voltage]", "parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcore2Voltage).unit]", snridVcore2Voltage)
    )
);
var compBackplane1 = new SysComponentInfo ('BACKPLANE1', "parent.I18N['BACKPLANE'] + ' 1'",
    new SysCompositeImage (
        'IBACKPLANE1',
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"85\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_L01.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"56\\" height=\\"39\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_L02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"60\\" height=\\"39\\">"',
            '"        <TABLE WIDTH=\\"60\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay1Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay2Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl1Bay3Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        </TABLE></TD>"',
            '"    <TD WIDTH=\\"154\\" height=\\"39\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_L03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"81\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_L04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['HARDDISK_NUMBER']", 
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay2Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl1Bay3Plug).currvalue",
            snsridHasFRU
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE1_BAY1',
            new triple (new Point (37, 85), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 13),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay1Plug)
        ),
        new triple ('IALARM_BACKPLANE1_BAY2',
            new triple (new Point (37, 99), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 11),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay2Plug)
        ),
        new triple ('IALARM_BACKPLANE1_BAY3',
            new triple (new Point (37, 113), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 9),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl1Bay3Plug)
        )
    )
);
var compBackplane2 = new SysComponentInfo ('BACKPLANE2', "parent.I18N['BACKPLANE'] + ' 2'",
    new SysCompositeImage (
        'IBACKPLANE2',
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"98\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_m01.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"108\\" height=\\"26\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_m02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"60\\" height=\\"26\\">"',
            '"        <TABLE WIDTH=\\"60\\" height=\\"26\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl2Bay1Plug).currvalue == 1 ? "hd_ok" : "hd_no_M") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl2Bay2Plug).currvalue == 1 ? "hd_ok" : "hd_no_M") + ".gif\\" BORDER=\\"0\\"></TD></TR></TABLE></TD>"',
            '"    <TD WIDTH=\\"102\\" height=\\"26\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_m03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"81\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_m04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['HARDDISK_NUMBER']", 
            "parent.once.GSensors.idAt(parent.once.snridBkpl2Bay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl2Bay2Plug).currvalue",
            snsridHasFRU
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE2_BAY1',
            new triple (new Point (105, 99), '"<img src=\\"" + parent.once.imgPath + "hd_M_e.gif\\">"', 13),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl2Bay1Plug)
        ),
        new triple ('IALARM_BACKPLANE2_BAY2',
            new triple (new Point (105, 113), '"<img src=\\"" + parent.once.imgPath + "hd_M_e.gif\\">"', 11),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl2Bay2Plug)
        )
    )
);

var compBackplane3 = new SysComponentInfo ('BACKPLANE3', "parent.I18N['BACKPLANE'] + ' 3'",
    new SysCompositeImage (
        'IBACKPLANE3',
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"85\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_R01.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"147\\" height=\\"39\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_R02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"60\\" height=\\"39\\">"',
            '"        <TABLE WIDTH=\\"60\\" height=\\"39\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl3Bay1Plug).currvalue == 1 ? "hd_ok" : "hd_no_R") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl3Bay2Plug).currvalue == 1 ? "hd_ok" : "hd_no_R") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"        <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkpl3Bay3Plug).currvalue == 1 ? "hd_ok" : "hd_no_R") + ".gif\\" BORDER=\\"0\\"></TD></TR></TABLE></TD>"',
            '"    <TD WIDTH=\\"63\\" height=\\"39\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_R03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"81\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_R04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['HARDDISK_NUMBER']", 
            "parent.once.GSensors.idAt(parent.once.snridBkpl3Bay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl3Bay2Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkpl3Bay3Plug).currvalue",
            snsridHasFRU
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE3_BAY1',
            new triple (new Point (148, 85), '"<img src=\\"" + parent.once.imgPath + "hd_R_e.gif\\">"', 13),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl3Bay1Plug)
        ),
        new triple ('IALARM_BACKPLANE3_BAY2',
            new triple (new Point (148, 99), '"<img src=\\"" + parent.once.imgPath + "hd_R_e.gif\\">"', 11),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl3Bay2Plug)
        ),
        new triple ('IALARM_BACKPLANE3_BAY3',
            new triple (new Point (148, 113), '"<img src=\\"" + parent.once.imgPath + "hd_R_e.gif\\">"', 9),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkpl3Bay3Plug)
        )
    )
);

var compPowerFan1 = new SysComponentInfo ('PWRFAN1', "parent.once.GSensorNames[parent.once.snridPowerFan1]", 'info_powerFan.jpg',
    new Tuple (
        new triple ("parent.I18N['STATUS']", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan1))", snridPowerFan1)
    )
);

var compPowerFan2 = new SysComponentInfo ('PWRFAN2', "parent.once.GSensorNames[parent.once.snridPowerFan2]", 'info_powerFan.jpg',
    new Tuple (
        new triple ("parent.I18N['STATUS']", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan2))", snridPowerFan2)
    )
);

var compRedundantPower = new SysComponentInfo ('RDTPOWER', "parent.I18N['POWER']",
    new SysCompositeImage (
        'IPOWER',
        new Tuple(
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"70\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_01.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"79\\" height=\\"82\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_02.gif\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"105\\" height=\\"82\\">"',
            '"    <TABLE WIDTH=\\"105\\" height=\\"82\\" BGCOLOR=\\"#DBDBDB\\" BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"    <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridPower1Plug).currvalue == 1 ? "power_ok" : "power_noUp") + ".gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"    <TR><TD><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridPower2Plug).currvalue == 1 ? "power_ok" : "power_noDn") + ".gif\\" BORDER=\\"0\\"></TD></TR></TABLE></TD>"',
            '"    <TD WIDTH=\\"86\\" height=\\"82\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_03.gif\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"53\\" colspan=\\"3\\"><IMG SRC=\\"" + parent.once.imgPath + "/power_04.gif\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['POWERMODULE'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1Plug))", snridPower1Plug),
        new triple ("parent.I18N['POWERMODULE'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2Plug))", snridPower2Plug),
        new triple ("parent.I18N['POWER_FAN'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan1))", snridPowerFan1),
        new triple ("parent.I18N['POWER_FAN'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPowerFan2))", snridPowerFan2),
        new triple ("parent.I18N['POWERCORD'] + ' 1'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower1AC))", snridPower1AC),
        new triple ("parent.I18N['POWERCORD'] + ' 2'", "getSnsrHealthDescEx(parent.once.GSensors.idAt(parent.once.snridPower2AC))", snridPower2AC)
    ),
    new Tuple (
        new triple ('IALARM_POWERPLUG_UP',
            new triple (new Point (70, 70), '"<img src=\\"" + parent.once.imgPath + "power_e.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower1Plug)
        ),
        new triple ('IALARM_POWERPLUG_DOWN',
            new triple (new Point (70, 112), '"<img src=\\"" + parent.once.imgPath + "power_e.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower2Plug)
        ),
        new triple ('IALARM_POWERAC_UP',
            new triple (new Point (70, 70), '"<img src=\\"" + parent.once.imgPath + "plug_e.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower1AC)
        ),
        new triple ('IALARM_POWERAC_DOWN',
            new triple (new Point (70, 112), '"<img src=\\"" + parent.once.imgPath + "plug_e.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridPower2AC)
        )
    )
);


var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var theSystemComponents = new Tuple (
    compRedundantPower,
    compPowerFan1,
    compPowerFan2,
    compBackplane1, 
    compBackplane2,
    compBackplane3,
    compBackplaneBoard1,
    compBackplaneBoard2,
    compBackplaneBoard3,
    compIOConnector, 
    compChassisFan1,
    compChassisFan2,
    compHotFan1,
    compHotFan2,
    compHotFan3,
    compHotFan4,
    compHotFan5,
    compHotFan6,
    compHotFan7,
    compMotherboard, 
    compPCI,
    compRiser,
    compMemory, 
    compCPU1, 
    compCPU2
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/rs260-e3_rs8/';
var theSystem = new SysModel ('model.jpg', chassis_rackmount);
var imgPanelFront = 'main_front.gif';
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 28, 169,  98, 216), compBackplane1),
            new AnArea (new Rect (112, 184, 182, 216), compBackplane2),
            new AnArea (new Rect (196, 170, 266, 216), compBackplane3)
        ),
        new Tuple (
            new quadruple ('AL_BACKPLANE1', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (54, 184)),
            new quadruple ('AL_BACKPLANE2', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE2'], new Point (138, 192)),
            new quadruple ('AL_BACKPLANE3', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE3'], new Point (222, 185))
        )
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 36, 163,  82, 169), compBackplaneBoard1),
            new AnArea (new Rect ( 36, 169,  82, 217), compBackplane1),
            new AnArea (new Rect ( 82, 163, 132, 169), compBackplaneBoard2),
            new AnArea (new Rect ( 80, 169, 133, 217), compBackplane2),
            new AnArea (new Rect (132, 163, 176, 169), compBackplaneBoard3),
            new AnArea (new Rect (131, 169, 176, 217), compBackplane3),
            new AnArea (new Rect (157,   8, 175,  22), compPowerFan1),
            new AnArea (new Rect (139,   8, 157,  22), compPowerFan2),
            new AnArea (new Rect (137,   8, 177, 108), compRedundantPower),
            new AnArea (new Rect (101,   5, 123,  21), compChassisFan1),
            new AnArea (new Rect ( 81,   5, 103,  21), compChassisFan2),
            new AnArea (new Rect ( 29, 138,  66, 153), compHotFan1),
            new AnArea (new Rect ( 65, 138, 102, 153), compHotFan2),
            new AnArea (new Rect (101, 138, 138, 153), compHotFan3),
            new AnArea (new Rect ( 29, 125,  66, 140), compHotFan4),
            new AnArea (new Rect ( 65, 125, 102, 140), compHotFan5),
            new AnArea (new Rect (101, 125, 138, 140), compHotFan6),
            new AnArea (new Rect (139, 138, 176, 153), compHotFan7),
            new AnArea (new Rect ( 75,  31,  81,  69), compPCI),            
            new AnArea (new Rect ( 69,  31,  75,  69), compRiser),
            new AnArea (new Rect (104,  29, 130,  73), compMemory),
            new AnArea (new Rect (112,  81, 130, 100), compCPU1),
            new AnArea (new Rect ( 86,  81, 104, 100), compCPU2),
            new AnArea (new Rect ( 39,  19, 136, 116), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_POWERS', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_POWERS'], new Point (149, 54)),
            new quadruple ('AL_POWERFAN1', parent.asID['IDV_TYPE_SNR'], snridPowerFan1, new Point (154, 6)),
            new quadruple ('AL_POWERFAN2', parent.asID['IDV_TYPE_SNR'], snridPowerFan2, new Point (136, 6)),
            new quadruple ('AL_CHASSISFAN1', parent.asID['IDV_TYPE_SNR'], snridFan8Speed, new Point (105, 5)),
            new quadruple ('AL_CHASSISFAN2', parent.asID['IDV_TYPE_SNR'], snridFan9Speed, new Point (85, 5)),
            new quadruple ('AL_HOTFAN1', parent.asID['IDV_TYPE_SNR'], snridHotFan1Speed, new Point (41, 141)),
            new quadruple ('AL_HOTFAN2', parent.asID['IDV_TYPE_SNR'], snridHotFan2Speed, new Point (77, 141)),
            new quadruple ('AL_HOTFAN3', parent.asID['IDV_TYPE_SNR'], snridHotFan3Speed, new Point (113, 141)),
            new quadruple ('AL_HOTFAN4', parent.asID['IDV_TYPE_SNR'], snridHotFan4Speed, new Point (41, 127)),
            new quadruple ('AL_HOTFAN5', parent.asID['IDV_TYPE_SNR'], snridHotFan5Speed, new Point (77, 127)),
            new quadruple ('AL_HOTFAN6', parent.asID['IDV_TYPE_SNR'], snridHotFan6Speed, new Point (113, 127)),
            new quadruple ('AL_HOTFAN7', parent.asID['IDV_TYPE_SNR'], snridHotFan7Speed, new Point (151, 141)),
            new quadruple ('AL_CPU1TEMP', parent.asID['IDV_TYPE_SNR'], snridCPU1Temperature, new Point (113, 81)),
            new quadruple ('AL_CPU2TEMP', parent.asID['IDV_TYPE_SNR'], snridCPU2Temperature, new Point (87, 81)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcore1Voltage, new Point (113, 81)),
            new quadruple ('AL_VCORE2', parent.asID['IDV_TYPE_SNR'], snridVcore2Voltage, new Point (87, 81)),
            new quadruple ('AL_MBTEMP', parent.asID['IDV_TYPE_SNR'], snridMBTemperature, new Point (80, 60)),
            new quadruple ('AL_BACKPLANE1', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (48, 182)),
            new quadruple ('AL_BACKPLANE2', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE2'], new Point (94, 182)),
            new quadruple ('AL_BACKPLANE3', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE3'], new Point (145, 182))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 13, 172,  57, 193), compPowerFan1),
            new AnArea (new Rect ( 13, 195,  57, 216), compPowerFan2),
            new AnArea (new Rect ( 11, 169,  77, 217), compRedundantPower),
            new AnArea (new Rect ( 94, 171, 140, 203), compChassisFan1),
            new AnArea (new Rect (138, 171, 180, 203), compChassisFan2),
            new AnArea (new Rect ( 77, 191, 171, 215), compIOConnector)
        ),
        new Tuple (
            new quadruple ('AL_POWERS', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_POWERS'], new Point (35, 185)),
            new quadruple ('AL_POWERFAN1', parent.asID['IDV_TYPE_SNR'], snridPowerFan1, new Point (26, 174)),
            new quadruple ('AL_POWERFAN2', parent.asID['IDV_TYPE_SNR'], snridPowerFan2, new Point (26, 197)),
            new quadruple ('AL_CHASSISFAN1', parent.asID['IDV_TYPE_SNR'], snridFan8Speed, new Point (108, 179)),
            new quadruple ('AL_CHASSISFAN2', parent.asID['IDV_TYPE_SNR'], snridFan9Speed, new Point (150, 179))
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('h',
        "parent.I18N['BACKPLANE'] + ' 1'", "(parent.once.theFRUInfo ? 'BP3LS-AR21' : '')",
        "parent.I18N['BACKPLANE'] + ' 2'", "(parent.once.theFRUInfo ? 'BP3LS-AR21' : '')",
        "parent.I18N['BACKPLANE'] + ' 3'", "(parent.once.theFRUInfo ? 'BP3LS-AR21' : '')"
    ),

    new GSysViewHealth ('f',
        "parent.I18N['BACKPLANE'] + ' 1'", "(parent.once.theFRUInfo ? 'BP3LS-AR21' : '')",
        "parent.I18N['BACKPLANE'] + ' 2'", "(parent.once.theFRUInfo ? 'BP3LS-AR21' : '')",
        "parent.I18N['BACKPLANE'] + ' 3'", "(parent.once.theFRUInfo ? 'BP3LS-AR21' : '')",
        "parent.I18N['BACKPLANE_NUMBER']", "3",
        "parent.I18N['USB_PORT']", "2"
    ),
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2",
        "parent.I18N['SCSI_PORT']", "1",
        "parent.I18N['POWERMODULE']", "2"

    )
);


//////////////////////////////////////////////
// The System Backplane and Power structure

var theSysBackplane = new Array ();

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE1']] = new SysBackplane (
    'BP3LS-AR21', 'h_bp.jpg', compBackplane1,
    new Tuple,
    new Tuple (
        new Tuple (snridBkpl1Bay1Plug),
        new Tuple (snridBkpl1Bay2Plug),
        new Tuple (snridBkpl1Bay3Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE1'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE2']] = new SysBackplane (
    'BP3LS-AR21', 'h_bp.jpg', compBackplane2,
    new Tuple,
    new Tuple (
        new Tuple (snridBkpl2Bay1Plug),
        new Tuple (snridBkpl2Bay2Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE2'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE3']] = new SysBackplane (
    'BP3LS-AR21', 'h_bp.jpg', compBackplane3,
    new Tuple,
    new Tuple (
        new Tuple (snridBkpl3Bay1Plug),
        new Tuple (snridBkpl3Bay2Plug),
        new Tuple (snridBkpl3Bay3Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE3'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);

var theSysPower = new SysPower (
    '_', compRedundantPower,
    new Tuple (
        new Tuple (snridPower1Plug, snridPower1AC, snridPowerFan1),
        new Tuple (snridPower2Plug, snridPower2AC, snridPowerFan2)
    ),
    false
);
